{-------------------------------------------------------------}
{
{    Traduvox - Mdulo de controle da traduo
{
{    Autor: Jose' Antonio Borges
{
{    Em Janeiro/2010
{
{-------------------------------------------------------------}

unit edtraduz;

interface
uses
    windows,
    classes,
    dvcrt,
    dvwin,
    dvExec,
    dvdigitexto,
    sysUtils,
    trvars,
    trmsg,
    trgoogle,
    trsintet,
    trnet;

procedure traduzBloco (tipoDestino: char; nomeArqDest: string);

implementation

const
    MAX_TRADUZIR = 30000;

procedure arquiva (s, nomeArq: string; pulandoLinha: boolean);
var arq: textFile;
begin
    assign (arq, nomeArq);
    try
        if FileExists(nomeArq) then
            append (arq)
        else
            rewrite (arq);
    except
        sintetiza ('Erro de arquivamento!');
        exit;
    end;
    if pulandoLinha then
        writeln (arq, s)
    else
        write (arq, s);
    closeFile (arq);
end;

procedure traduzFraseDireta (tipoDestino: char; s: string);
var
    status: string;
    s2: string;
    dir: string;
    tempPath, tempFile: packed array [0..MAX_PATH] of char;
    nomeTemp: string;
begin
    GetTempPath(sizeof(tempPath), tempPath);
    if GetTempFileName (tempPath, 'tmp', 0, tempFile) = 0 then
        begin
            mensagem ('TRERTRAB', 2);   {'Erro ao criar o arquivo de trabalho'}
            exit;
        end;
    nomeTemp := strPas(tempFile);

    if fileExists(nomeTemp) then
        DeleteFile(nomeTemp);
    nomeTemp := ChangeFileExt(nomeTemp, '.txt');
    if fileExists(nomeTemp) then
        DeleteFile(nomeTemp);

    status := traduzArquivoGoogle (nomeTemp, s, linguaOrig, s2, linguaDest);

    if copy (status, 1, 3)  <> '200' then
        begin
            mensagem ('TRERRO', 1);   {'Erro no Google Translator, cdigo:'}
            sintWriteln (status);
        end
    else
        grava s2 na linha  no edivox
end;

procedure traduzArquivo (nomeArqOrig: string; tipoDestino: char; nomeArqDest: string);
var
    nomeArqTrab: string;
    status: string;

    tempPath, tempFile: array [0..MAX_PATH] of char;
    textoOriginal: TStringList;
    listaResult: TStringList;

    autoParag:  boolean;

    tamanhoOriginal: integer;
    x, y: integer;
    c1, c2: char;
    p, i:  integer;
    paragrafo,
    acumulado,
    aTraduzir,
    traduzido: string;

label cancela;
begin

se no tem texto selecionado sai.

    if length (textoOriginal.Text) > MAX_TRADUZIR then
        mensagem ('TREXCED', 2);   {'O texto excedeu 32000 letras e ser truncado.'}

    GetTempPath(sizeof(tempPath), tempPath);
    if GetTempFileName (tempPath, 'tmp', 0, tempFile) = 0 then
        begin
            mensagem ('TRERTRAB', 2);   {'Erro ao criar o arquivo de trabalho'}
            exit;
        end;
    nomeArqTrab := strPas(tempFile);

    mensagem ('TRINITRD', 2);  {'Iniciando a traduo'}

    acumulado := '';
    tamanhoOriginal := 0;
    for i := 0 to textoOriginal.Count-1 do
        begin
            paragrafo := textoOriginal.Strings[i];
            if acumulado = '' then
                acumulado := paragrafo
            else
                if (trim (paragrafo) <> '') and
                    (copy (paragrafo, 1, 1) <> ' ') and
                    (copy (paragrafo, 1, 1) <> ^I)  then
                    acumulado := acumulado + ' ' + trim(paragrafo)
                else
                    acumulado := acumulado + '<p>' + #$0d + #$0a + paragrafo;
            tamanhoOriginal := tamanhoOriginal + length(paragrafo);
            if tamanhoOriginal > MAX_TRADUZIR then
                break;
        end;

    aTraduzir := copy (acumulado, 1, length(acumulado));
    if aTraduzir [length(aTraduzir)] <> #$0a then
        aTraduzir := aTraduzir + ' ';

    status := traduzArquivoGoogle (nomeArqOrig, aTraduzir, linguaOrig, traduzido, linguaDest);
    if (copy (status,1,3)  <> '200') then
        begin
            sintetiza ('Erro no Google Translator, cdigo: ' + status);
            sintetiza ('Pargrafo do erro: ' + paragrafo);
            goto cancela;
        end;

    if (copy (traduzido, length(traduzido)-2, 3) <> '<p>') or
       (copy (traduzido, length(traduzido)-2, 3) <> '<P>') then
        traduzido := traduzido + ' ';   // para no colapsar pargrafos divididos
    p := pos ('<p>', traduzido);
    if p = 0 then
        p := pos ('<P>', traduzido);
    while p <> 0 do
        begin
            if copy (traduzido, p+2, 2) = '> ' then
                delete (traduzido, p, 4)
            else
                delete (traduzido, p, 3);
            p := pos ('<p>', traduzido);
            if p = 0 then
                p := pos ('<P>', traduzido);
        end;
    arquiva (traduzido, nomeArqTrab, false);

cancela:
    limpaBufTec;

ler as linhas do arquivo nomeArqTrab e escrever na linha do Edivox

    deleteFile (nomeArqTrab);
end;


end.
