{-------------------------------------------------------------}
{
{    Traduvox - tradutor de textos usando o Google Translator
{
{    Autor: Jose' Antonio Borges
{
{    Em 14/05/2010
{
{-------------------------------------------------------------}

program traduvox;
uses
  dvwin,
  dvcrt,
  dvinet,
  sysUtils,
  trmsg,
  trvars,
  trintera,
  trtraduz,
  trsintet;

{$R *.res}

procedure termina;
begin
    writeln;
    mensagem ('TRFIM', 0);   {'Fim do Traduvox'}
    fechaWinSock;
    sintFim;
    doneWinCrt;
end;

function pegaParam (var param: string): string;
var p: integer;
begin
    result := '';
    param := trim (param);
    if param = '' then exit;

    if param[1] = '"' then
        begin
            delete (param, 1, 1);
            p := pos ('"', param);
            if p = 0 then
                begin
                    result := param;
                    param := '';
                end
            else
                begin
                    result := copy (param, 1, p-1);
                    delete (param, 1, p);
                    param := trim (param);
                end;
        end
    else
        begin
             p := pos (' ', param);
             if p = 0 then
                 begin
                     result := param;
                     param := '';
                 end
             else
                 begin
                     result := copy (param, 1, p-1);
                     delete (param, 1, p);
                     param := trim (param);
                 end;
        end;
end;

procedure inicializa;
label erro;
var params: string;
    dir: string;
begin
    dir := sintAmbiente ('TRADUVOX', 'DIRTRADUVOX');
    if dir = '' then
        dir := 'c:\winvox\som\traduvox';
    sintInic (0, dir);

    textBackground (BLUE);
    mensagem ('TRINIC', 0);    {'TRADUVOX - NCE/UFRJ - v.'}
    sintWriteln (versao);
    textBackground (BLACK);
    writeln; writeln;

    textColor (GREEN);
    mensagem ('TRGOOGLE', -2);  {'Este programa utiliza a tecnologia Google Translator'}
    textColor (WHITE);

    while sintFalando do delay (100);   // no reseta sapi enquanto no terminar de falar

    if sapiPresente then
        presetSapi;

    interativo := paramCount = 0;
    if not interativo then
        begin
            if paramcount < 3 then goto erro;
            params := CmdLine;

            pegaParam (params);   // nome do programa;
            linguaOrig  := pegaParam (params);
            linguaDest  := pegaParam (params);
            nomeArqOrig := pegaParam (params);
            nomeArqDest := pegaParam (params);

            if not fileExists (nomeArqOrig) then
                begin
                    mensagem ('TRARQNAO', 2);  {'Arquivo origem no existe'}
                    goto erro;
                    termina;
                end;
        end;

    abreWinSock;

    exit;
erro:
    mensagem ('TRUSO1', 1);  {'Uso: traduvox linguaorig linguadest arqorigem [arqdestino]'}
    mensagem ('TRUSO2', 1);  {'Os cdigos usados para as lnguas so os mesmos do Google'}
    mensagem ('TRUSO3', 2);  {'PT = Portugus  EN = Ingls  SP = espanhol etc...'}
    mensagem ('TRENTER', 1); {'Tecle enter'}
    readln;
    sintFim;
    doneWinCrt;
end;

begin
    inicializa;
    setWindowTitle ('Traduvox');
    if interativo then
        processaInterativo
    else
    begin
        if nomeArqDest <> '' then
            traduzArquivo (nomeArqOrig, 'A', nomeArqDest)
        else
            traduzArquivo (nomeArqOrig, 'L', nomeArqDest);
    end;
    termina;
end.
