unit trgoogle;

interface
uses
  dvwin,
  dvcrt,
  dvinet,
  winsock,
  sysUtils,
  classes,
  trMsg,
  trnet;


{
function antigaTraduzFraseGoogle (aTraduzir,linguaOrig: string;
                            var traduzido: string; linguaDest: string): string;
}
function traduzArquivoGoogle (nomeArq: string; aTraduzir, linguaOrig: string;
                              var traduzido: string; linguaDest: string): string;

implementation
var
    sock: integer;
    pbuf: PbufRede;

{-------------------------------------------------------------}

function utfToAnsi (s: string): string;
var b, b2: byte;
    s2: string;
    i: integer;
begin
    s2 := '';
    s := s + ' ';
    i := 1;
    while i <= length (s) - 1 do
        begin
            b := ord(s[i]);
            if (b < $80) or ((b and $e0) <> $c0)then
                s2 := s2 + s[i]
            else
                begin
                    b2 := ord (s[i+1]) and $3f;
                    b := (b and $03) shl 6;
                    s2 := s2 + chr(b or b2);
                    i := i + 1;
                end;
            i := i + 1;
        end;
    utfToAnsi := s2;
end;

{-------------------------------------------------------------}

function ansiToUTF (s: string): string;
var b: byte;
    s2: string;
    i: integer;
begin
    s2 := '';
    for i := 1 to length (s) do
        begin
            b := ord(s[i]);
            if b <= $7f then
                s2 := s2 + s[i]
            else
                s2 := s2 + chr ($c0 or ((b shr 6) and $3f)) +
                           chr ($80 or (b and $3f));
        end;
    ansiToUTF := s2;
end;

{-------------------------------------------------------------}

function removeHexas (s: string): string;
var i, n1, n2: integer;
    s2: string;
begin
    s2 := '';
    i := 1;
    while i <= length (s) do
        begin
            if s[i] <> '%' then
                s2 := s2 + s[i]
            else
                begin
                    i := i + 1;
                    n1 := ord(upcase(s[i])) - ord('0');
                    if n1 > 9 then n1 := n1 - 7;

                    i := i + 1;
                    n2 := ord(upcase(s[i])) - ord('0');
                    if n2 > 9 then n2 := n2 - 7;

                    s2 := s2 + chr ((n1 shl 4) + n2);
                end;
            i := i + 1;
        end;
    result := s2;
end;

{-------------------------------------------------------------}

function adicionaHexas (s: string): string;
var i: integer;
    s2: string;
begin
    s2 := '';
    for i := 1 to length(s) do
        begin
            if ord(s[i]) = $20 then
                s2 := s2 + '+'
            else
            if (ord(s[i]) > $20) and (ord(s[i]) < $80) and
               (not (s[i] in ['#', '%', '&', '<', '>', '\']))then
                s2 := s2 + s[i]
            else
                s2 := s2 + '%' + lowerCase (intToHex (ord(s[i]), 2));
        end;
    result := s2;
end;

{-------------------------------------------------------------}
(*
function traduzFraseGoogle (aTraduzir, linguaOrig: string;
                            var traduzido: string; linguaDest: string): string;
var
    s, status: string;
    c: char;
    p: integer;

    nomePag,
    scheme: string;

    spost: string;
    nomeArquivo: string;

begin
    result := '';
    nomePag := 'translate.google.com';
    scheme := 'HTTPS';

    aTraduzir := adicionaHexas(ansiToUtf ('@#@'+aTraduzir));
    getDir(0,nomeArquivo);
    nomeArquivo := nomeArquivo + '\teste.txt';

    spost := 'sl='      + linguaOrig +
             '&tl='     + linguaDest +
             '&js=n'    +
             '&prev=_t' +
             '&hl='     + converteValorparaHTTP('pt-BR') +
             '&ie='     + converteValorparaHTTP('ISO-8859-1') +
             '&text='   + atraduzir +
             '&file='   + converteValorparaHTTP(nomeArquivo) +
             '&edit'    + converteValorparaHTTP ('-') + 'text=';

    montaCookies (nomePag);

    s :=   'POST / HTTP/1.0'            + CRLF +
           'Host: translate.google.com' + CRLF +
           'Connection: Close'          + CRLF +
           'Accept-Language: pt-br'     + CRLF +
           'UA-CPU: x86'                + CRLF +
           'User-Agent: Webvox 5.4'     + CRLF +
           mensagemCookies +
           'Content-Type: application/x-www-form-urlencoded' + CRLF +
           'Content-Length: ' + intToStr(length(spost))      + CRLF + CRLF +
           spost;

    if scheme = 'HTTPS' then
        sock := abreConexaoSSL (nomePag, 443)
    else
        sock := abreConexao (nomePag, 80);
    if sock <= 0 then
        begin
            mensagem ('TRNOGOOG',2);  {'Google translator est inacessvel.'}
            exit;
        end;

    pbuf := inicBufRede(sock);
    writeRede (sock, s);

    {*
     *  Traz cabealho da mensagem
     *}
    nlinCabecHTTP := 0;

    if not readlnBufRede (pbuf, s, 10) then
        s := '';
    status := s;

    {*  Primeira linha: cdigo da resposta *}

    delete (status, 1, pos (' ', status));
    result := status;

    {* Armazena todas as linhas do cabecalho *}

    while s <> '' do
    begin
        inc(nlinCabecHTTP);
        cabecHTTP[nlinCabecHTTP] := s;
        if not readlnBufRede (pbuf, s, 10) then
            s := '';
    end;

    if (status <> '') and ((status[1] = '2') or (status[1] = '3')) then
    begin
        cookie := obtemCookie;
        if cookie <> '' then
            gravaCookie (cookie, nomePag);
    end;

    {*
     *  Traz o corpo da mensagem.
     *}
    while leCaracBufRede (pbuf, c) do
       traduzido := traduzido + c;

    fimBufRede(pbuf);
    closeSocket (sock);

    if (copy (status, 1, 3) <> '200') then
        exit;

    {*  Procura e extrai texto traduzido *}

    p := pos ('@ # @', traduzido);
    if p = 0 then
        p := pos ('# @ @', traduzido);
    if p = 0 then
        p := pos ('@ @ #', traduzido);
    if (p <> 0) then
    begin
        delete (traduzido, 1, p+4);
        while (traduzido <> '') and (traduzido[1] = ' ') do
            delete (traduzido, 1, 1);
    end
    else
    begin
        p := pos ('@#@', traduzido);
        if (p <> 0) then
        begin
            delete (traduzido, 1, p+2);
            p := pos ('@#@', traduzido);
        end;
        if linguaOrig <> linguaDest then
        begin
            if (p <> 0) then
            begin
                delete (traduzido, 1, p+2);
                p := pos ('@#@', traduzido);
            end;
        end;
        if (p <> 0) then
        begin
            delete (traduzido, 1, p+2);
            while (traduzido <> '') and (traduzido[1] = ' ') do
                delete (traduzido, 1, 1);
        end
        else
            traduzido := '';
    end;

    if traduzido <> '' then
    begin
        p := pos ('</span>', traduzido);
        if (p <> 0) then
            delete (traduzido, p, 99999);
        traduzido := converteValorDeHTML(traduzido);
    end;

end;
*)

{-------------------------------------------------------------}

function traduzArquivoGoogle (nomeArq: string; aTraduzir, linguaOrig: string;
                              var traduzido: string; linguaDest: string): string;
var
    s, status: string;
    c: char;
    p: integer;

    nomePag,
    scheme: string;

    spost: string;
    sboundary: string;

begin
    result := '';
    nomePag := 'translate.google.com';
    scheme := 'HTTPS';

    sboundary := geraChaveMime;

    if nomeArq = '' then
        exit;
{
    begin
        getDir(0,nomeArq);
        nomeArq := nomeArq + '\teste.txt';
    end;
}

    spost :=            { Source Language }
                '--' + sboundary + CRLF +
                'Content-Disposition: form-data; name="sl"'     + CRLF +
                CRLF +
                linguaOrig + CRLF +
                        { Trarget Language }
                '--' + sboundary + CRLF +
                'Content-Disposition: form-data; name="tl"'     + CRLF +
                CRLF +
                linguaDest + CRLF +
                        { js = n }
                '--' + sboundary + CRLF +
                'Content-Disposition: form-data; name="js"'     + CRLF +
                CRLF +
                'n' + CRLF +
                        { prev=_t }
                '--' + sboundary + CRLF +
                'Content-Disposition: form-data; name="prev"'   + CRLF +
                CRLF +
                '_t' + CRLF +
                        { Home Language }
                '--' + sboundary + CRLF +
                'Content-Disposition: form-data; name="hl"'     + CRLF +
                CRLF +
                'pt-BR' + CRLF +
                        { Encoding }
                '--' + sboundary + CRLF +
                'Content-Disposition: form-data; name="ie"'     + CRLF +
                CRLF +
                'ISO-8859-1' + CRLF +
                        { text= }
                '--' + sboundary + CRLF +
                'Content-Disposition: form-data; name="text"'   + CRLF +
                CRLF +
                '' + CRLF +
                        { file= }
                '--' + sboundary + CRLF +
                'Content-Disposition: form-data; name="file"; ' +
                                'filename="' + nomeArq + '"'    + CRLF +
                'Current-Type: text/plain'                      + CRLF +
                CRLF +
                aTraduzir + CRLF +
                        { edit-text= }
                '--' + sboundary + CRLF +
                'Content-Disposition: form-data; name="edit-text"' + CRLF +
                CRLF +
                '' + CRLF +
                        { Fim do post }
                '--' + sboundary + '--' + CRLF;

    montaCookies (nomePag);

    s :=   'POST /translate_f HTTP/1.0'             + CRLF +
           'Host: translate.googleusercontent.com'  + CRLF +
           'Connection: Close'                      + CRLF +
           'Accept-Language: pt-br'                 + CRLF +
           'UA-CPU: x86'                            + CRLF +
           'User-Agent: Webvox 5.4'                 + CRLF +
           mensagemCookies +
           'Content-Type: multipart/form-data; boundary=' + sboundary + CRLF +
           'Content-Length: ' + intToStr(length(spost)) + CRLF + CRLF +
           spost;

    if scheme = 'HTTPS' then
        sock := abreConexaoSSL (nomePag, 443)
    else
        sock := abreConexao (nomePag, 80);
    if sock <= 0 then
        begin
            mensagem ('TRNOGOOG',2);  {'Google translator est inacessvel.'}
            exit;
        end;

    pbuf := inicBufRede(sock);
    writeRede (sock, s);

    {*
     *  Traz cabealho da mensagem
     *}
    nlinCabecHTTP := 0;

    if not readlnBufRede (pbuf, s, 10) then
        s := '';
    status := s;

    {*  Primeira linha: cdigo da resposta *}

    delete (status, 1, pos (' ', status));
    result := status;

    {* Armazena todas as linhas do cabecalho *}

    while s <> '' do
    begin
        inc(nlinCabecHTTP);
        cabecHTTP[nlinCabecHTTP] := s;
        if not readlnBufRede (pbuf, s, 10) then
            s := '';
    end;

    if (status <> '') and ((status[1] = '2') or (status[1] = '3')) then
    begin
        cookie := obtemCookie;
        if cookie <> '' then
            gravaCookie (cookie, nomePag);
    end;

    {*
     *  Traz o corpo da mensagem.
     *}
    while leCaracBufRede (pbuf, c) do
       traduzido := traduzido + c;

    fimBufRede(pbuf);
    closeSocket (sock);

    if (copy (status, 1, 3) <> '200') then
        exit;

    {*  Procura e extrai texto traduzido *}

    p := pos ('<pre>', traduzido);
    if (p <> 0) then
        delete (traduzido, 1, p+4)
    else
        traduzido := '';

    if traduzido <> '' then
    begin
        p := pos ('</pre>', traduzido);
        if (p <> 0) then
            delete (traduzido, p, 99999);
        traduzido := converteValorDeHTML(traduzido);
    end;

end;

end.

